/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
import * as r from "react";
import e from "prop-types";
import { cloneDate as T, isEqual as qe } from "@progress/kendo-date-math";
import { Button as G } from "@progress/kendo-react-buttons";
import { caretAltUpIcon as Ne, caretAltDownIcon as _e } from "@progress/kendo-svg-icons";
import { useInternationalization as Fe, useLocalization as Be } from "@progress/kendo-react-intl";
import { validatePackage as He, useId as ze, useUnstyled as Ue, usePropsContext as Z, classNames as b, uDateInput as h, createPropsContext as We, getActiveElement as $ } from "@progress/kendo-react-common";
import { FloatingLabel as je } from "@progress/kendo-react-labels";
import { DateInput as Ke } from "@progress/kendo-dateinputs-common";
import { DEFAULT_FORMAT as Ye, DEFAULT_FORMAT_PLACEHOLDER as Je, isInRange as Xe } from "./utils.mjs";
import { packageMetadata as Ge } from "../package-metadata.mjs";
import { nullable as c, MAX_DATE as Ze, MIN_DATE as $e, MIN_TIME as Qe, MAX_TIME as et } from "../utils.mjs";
import { increaseValue as P, messages as S, decreaseValue as k } from "../messages/index.mjs";
import { isInTimeRange as tt } from "../timepicker/utils.mjs";
import nt from "../common/ClearButton.mjs";
import { DateInputIntl as at } from "./dateInputIntl.mjs";
const rt = "Please enter a valid value!", ee = r.forwardRef((t, te) => {
  var X;
  He(Ge);
  const ne = ze(t.id), ae = Fe(), E = Be(), re = Ue(), q = Z(Q, t).unstyled || re, {
    format: L = i.format,
    size: ie = i.size,
    rounded: oe = i.rounded,
    fillMode: le = i.fillMode,
    formatPlaceholder: ue = i.formatPlaceholder,
    spinners: se = i.spinners,
    disabled: I = i.disabled,
    min: ce = i.min,
    max: de = i.max,
    minTime: me = i.minTime,
    maxTime: fe = i.maxTime,
    validityStyles: ge = i.validityStyles,
    validationMessage: N = i.validationMessage,
    placeholder: f = i.placeholder,
    enableMouseWheel: ve = i.enableMouseWheel,
    autoCorrectParts: ye = i.autoCorrectParts,
    autoSwitchParts: be = i.autoSwitchParts,
    allowCaretMode: he = i.allowCaretMode,
    twoDigitYearMax: Ee = i.twoDigitYearMax,
    ariaHasPopup: Ie = i.ariaHasPopup,
    autoFocus: Oe = i.autoFocus
  } = Z(Q, t), d = () => C.current !== void 0 ? C.current : o.current && o.current.value, De = () => {
    const { year: n, month: a, day: y, hours: R, minutes: w, seconds: M } = x.current;
    return (!n || !a || !y || !R || !w || !M) && (n || a || y || R || w || M);
  }, _ = () => {
    const n = o.current && o.current.currentText || "", a = d();
    return f != null && !pe.focused && !a ? f : n;
  }, F = () => t.required !== void 0 ? t.required : !1, p = () => {
    const n = d() || t.value, a = ce, y = de, R = Xe(n, a, y) && tt(n, me, fe), w = N !== void 0, M = (!F() || n != null) && R, Ve = t.valid !== void 0 ? t.valid : M;
    return {
      customError: w,
      rangeOverflow: n && y.getTime() < n.getTime() || !1,
      rangeUnderflow: n && n.getTime() < a.getTime() || !1,
      valid: Ve,
      valueMissing: n === null
    };
  }, xe = () => {
    l.current && l.current.focus();
  }, B = () => new at(ae), O = () => {
    const n = d();
    return {
      format: L,
      steps: t.steps,
      formatPlaceholder: ue,
      placeholder: f,
      selectPreviousSegmentOnBackspace: !0,
      value: t.value || n,
      intlService: B(),
      autoFill: t.autoFill !== void 0 ? t.autoFill : !1,
      enableMouseWheel: ve,
      autoCorrectParts: ye,
      autoSwitchParts: be,
      autoSwitchKeys: t.autoSwitchKeys || [],
      twoDigitYearMax: Ee,
      allowCaretMode: he
    };
  }, Ce = (n) => {
    u.current && u.current.classList.add("k-focus"), j({ focused: !0 });
  }, Re = (n) => {
    u.current && u.current.classList.remove("k-focus"), j({ focused: !1 });
  }, we = (n, a) => typeof n != typeof a ? !0 : typeof n == "string" && typeof a == "string" ? n !== a : typeof n == "object" && typeof a == "object" ? JSON.stringify(n) !== JSON.stringify(a) : !1, Me = (n) => typeof n == "string" ? n : {
    inputFormat: n,
    displayFormat: n
  }, H = (n) => {
    C.current = d(), Ae(), m.current = n, C.current = void 0;
  }, z = (n) => {
    t.onChange && t.onChange(n);
  }, U = (n) => {
    $(document) === l.current && n.preventDefault();
  }, Te = () => new Ke(l.current, {
    ...O(),
    format: Me(O().format),
    events: {
      focus: Ce,
      blur: Re,
      valueChange: H,
      click: z
    }
  }), W = () => {
    l.current && l.current.setCustomValidity && l.current.setCustomValidity(
      p().valid ? "" : N || i.validationMessage
    );
  }, Pe = (n) => {
    !l.current || !o.current || H(n);
  }, Se = (n) => {
    n.preventDefault();
    const a = $(document);
    l.current && a !== l.current && l.current.focus({ preventScroll: !0 });
  }, s = (n) => {
    const a = d();
    m.current && t.onChange && !qe(m.current.oldValue, a) && t.onChange.call(void 0, {
      syntheticEvent: n,
      nativeEvent: m.current.event,
      value: m.current.value,
      target: D.current
    }), m.current = null;
  }, ke = (n) => {
    var a;
    (a = o.current) == null || a.modifyDateSegmentValue(1), s(n);
  }, Le = (n) => {
    var a;
    (a = o.current) == null || a.modifyDateSegmentValue(-1), s(n);
  }, D = r.useRef(null), l = r.useRef(null), u = r.useRef(null);
  r.useImperativeHandle(
    D,
    () => ({
      props: t,
      get options() {
        return O();
      },
      get text() {
        return _();
      },
      get element() {
        return l.current;
      },
      get name() {
        return t.name;
      },
      get value() {
        return d();
      },
      get validity() {
        return p();
      },
      // hidden methods
      focus: xe,
      updateOnPaste: Pe
    })
  ), r.useImperativeHandle(te, () => D.current);
  const o = r.useRef(null), x = r.useRef(null), A = r.useRef(!1), C = r.useRef(null), m = r.useRef(null), g = r.useRef(t), [pe, j] = r.useState({ focused: !1 }), [, Ae] = r.useReducer((n) => n + 1, 0);
  r.useLayoutEffect(() => {
    A.current || (o.current = Te(), x.current = o.current.dateObject, A.current = !0);
  }, []), r.useEffect(() => (W(), A.current || u.current && u.current.addEventListener("wheel", U, { passive: !1 }), () => {
    u.current && u.current.removeEventListener("wheel", U);
  }), []), r.useEffect(() => {
    W(), o.current && ((we(g.current.format, L) || g.current.readonly !== t.readonly || g.current.steps !== t.steps || B().locale !== o.current.options.intlService.locale) && o.current.setOptions(O(), !0), g.current.value !== t.value && (x.current.getValue() !== null || De() && t.value !== null) && x.current.setValue(t.value), t.ariaExpanded !== void 0 && t.ariaExpanded && (o.current.options.placeholder = null), t.ariaExpanded !== void 0 && !t.ariaExpanded && (o.current.options.placeholder = f), o.current.refreshElementValue(), g.current = {
      format: L,
      readonly: t.readonly,
      ariaExpanded: t.ariaExpanded,
      steps: t.steps,
      value: t.value
    });
  });
  const K = t.id || ne + "-accessibility-id", v = q && q.uDateInput, Y = _(), V = !ge || p().valid;
  t._ref && (t._ref.current = D.current);
  const J = /* @__PURE__ */ r.createElement(
    "span",
    {
      ref: (n) => u.current = n,
      style: t.label ? void 0 : { width: t.width },
      dir: t.dir,
      className: b(
        h.wrapper({
          c: v,
          size: ie,
          fillMode: le,
          rounded: oe,
          disabled: I,
          required: F(),
          invalid: !V
        }),
        t.className
      )
    },
    /* @__PURE__ */ r.createElement(
      "input",
      {
        ref: (n) => l.current = n,
        role: t.ariaRole || "textbox",
        readOnly: t.readonly,
        tabIndex: t.tabIndex || 0,
        disabled: I,
        title: t.title !== void 0 ? t.title : Y,
        type: "text",
        spellCheck: !1,
        autoComplete: "off",
        autoCorrect: "off",
        autoFocus: Oe,
        className: b(h.inputInner({ c: v })),
        id: K,
        value: Y,
        "aria-label": t.ariaLabel,
        "aria-labelledby": t.ariaLabelledBy,
        "aria-describedby": t.ariaDescribedBy,
        "aria-haspopup": Ie,
        "aria-disabled": I,
        "aria-expanded": t.ariaExpanded,
        "aria-controls": t.ariaControls,
        "aria-required": t.required,
        "aria-invalid": !V,
        onKeyDown: s,
        onChange: s,
        onWheel: s,
        onInput: s,
        onClick: s,
        name: t.name,
        ...t.inputAttributes
      }
    ),
    t.children,
    t.clearButton && t.value && /* @__PURE__ */ r.createElement(nt, { onClick: z, key: "clearbutton" }),
    se && /* @__PURE__ */ r.createElement("span", { className: b(h.inputSpinner({ c: v })), onMouseDown: Se }, /* @__PURE__ */ r.createElement(
      G,
      {
        tabIndex: -1,
        type: "button",
        rounded: null,
        className: b(h.spinnerIncrease({ c: v })),
        icon: "caret-alt-up",
        svgIcon: Ne,
        "aria-label": E.toLanguageString(P, S[P]),
        title: E.toLanguageString(P, S[P]),
        onClick: ke
      }
    ), /* @__PURE__ */ r.createElement(
      G,
      {
        tabIndex: -1,
        type: "button",
        rounded: null,
        className: b(h.spinnerDecrease({ c: v })),
        icon: "caret-alt-down",
        svgIcon: _e,
        "aria-label": E.toLanguageString(k, S[k]),
        title: E.toLanguageString(k, S[k]),
        onClick: Le
      }
    ))
  );
  return t.label ? /* @__PURE__ */ r.createElement(
    je,
    {
      label: t.label,
      editorId: K,
      editorValue: (X = l.current) == null ? void 0 : X.value,
      editorValid: V,
      editorDisabled: I,
      children: J,
      style: { width: t.width }
    }
  ) : J;
});
ee.propTypes = {
  value: e.instanceOf(Date),
  format: e.oneOfType([
    c(e.string),
    e.shape({
      skeleton: e.string,
      pattern: e.string,
      date: e.oneOf(["short", "medium", "long", "full"]),
      time: e.oneOf(["short", "medium", "long", "full"]),
      datetime: e.oneOf(["short", "medium", "long", "full"]),
      era: e.oneOf(["narrow", "short", "long"]),
      year: e.oneOf(["numeric", "2-digit"]),
      month: e.oneOf(["numeric", "2-digit", "narrow", "short", "long"]),
      day: e.oneOf(["numeric", "2-digit"]),
      weekday: e.oneOf(["narrow", "short", "long"]),
      hour: e.oneOf(["numeric", "2-digit"]),
      hour12: e.bool,
      minute: e.oneOf(["numeric", "2-digit"]),
      second: e.oneOf(["numeric", "2-digit"]),
      timeZoneName: e.oneOf(["short", "long"])
    })
  ]),
  formatPlaceholder: e.oneOfType([
    e.oneOf(["wide", "narrow", "short", "formatPattern"]).isRequired,
    e.shape({
      year: e.string.isRequired,
      month: e.string.isRequired,
      day: e.string.isRequired,
      hour: e.string.isRequired,
      minute: e.string.isRequired,
      second: e.string.isRequired
    })
  ]),
  width: e.oneOfType([e.string, e.number]),
  tabIndex: e.number,
  title: e.string,
  steps: e.shape({
    year: c(e.number),
    month: c(e.number),
    day: c(e.number),
    hour: c(e.number),
    minute: c(e.number),
    second: c(e.number)
  }),
  min: e.instanceOf(Date),
  max: e.instanceOf(Date),
  disabled: e.bool,
  spinners: e.bool,
  name: e.string,
  dir: e.string,
  label: e.string,
  id: e.string,
  ariaLabelledBy: e.string,
  ariaDescribedBy: e.string,
  ariaLabel: e.string,
  ariaRole: e.string,
  ariaHasPopup: e.oneOfType([
    e.bool,
    e.oneOf(["grid", "dialog"])
  ]),
  ariaExpanded: e.oneOfType([e.bool]),
  onChange: e.func,
  validationMessage: e.string,
  required: e.bool,
  valid: e.bool,
  size: e.oneOf([null, "small", "medium", "large"]),
  rounded: e.oneOf([null, "small", "medium", "large", "full"]),
  fillMode: e.oneOf([null, "solid", "flat", "outline"]),
  autoFocus: e.bool,
  inputAttributes: e.object
};
const i = {
  format: Ye,
  size: "medium",
  rounded: "medium",
  fillMode: "solid",
  formatPlaceholder: Je,
  spinners: !1,
  disabled: !1,
  max: T(Ze),
  min: T($e),
  minTime: T(Qe),
  maxTime: T(et),
  validityStyles: !0,
  validationMessage: rt,
  placeholder: null,
  enableMouseWheel: !0,
  autoCorrectParts: !0,
  autoSwitchParts: !0,
  allowCaretMode: !1,
  twoDigitYearMax: 68,
  ariaHasPopup: "grid",
  autoFocus: !1
}, Q = We();
ee.displayName = "KendoReactDateInput";
export {
  ee as DateInput,
  Q as DateInputPropsContext,
  i as dateInputDefaultProps
};
